Index: replex/replex.c
===================================================================
--- replex/replex.c	(revision 18755)
+++ replex/replex.c	(working copy)
@@ -1778,9 +1991,11 @@
 	ring_init(&rx->vrbuffer, rx->videobuf);
 	if (rx->itype == REPLEX_TS || rx->itype == REPLEX_AVI)
 		init_pes_in(&rx->pvideo, 0xE0, &rx->vrbuffer, 0);
-	else {
+	else if (rx->itype == REPLEX_PS){
 		init_pes_in(&rx->pvideo, 0, NULL, 1);
-	}
+//		find_pes_in(rx);
+	} else init_pes_in(&rx->pvideo, 0, NULL, 1);
+	
 	rx->pvideo.priv = (void *) rx;
 	ring_init(&rx->index_vrbuffer, INDEX_BUF);
 	memset(&rx->seq_head, 0, sizeof(sequence_t));
@@ -1828,7 +2043,7 @@
 	}	
 	
 	if (rx->itype == REPLEX_TS){
-		if (replex_fill_buffers(rx, mbuf)< 0) {
+		if (replex_fill_buffers(rx, mbuf)< 0){
 			fprintf(stderr,"error filling buffer\n");
 			exit(1);
 		}
@@ -1875,12 +2090,12 @@
 			exit(1);
 		}
 
-		if (replex_fill_buffers(rx, buf+re)< 0) {
+		if (replex_fill_buffers(rx, buf+re)< 0){
 			fprintf(stderr,"error filling buffer\n");
 			exit(1);
 		}
 	} else {
-		if (replex_fill_buffers(rx, mbuf)< 0) {
+		if (replex_fill_buffers(rx, mbuf)< 0){
 			fprintf(stderr,"error filling buffer\n");
 			exit(1);
 		}
@@ -1901,24 +2116,27 @@
 		do {
 			while (ring_avail(&rx->index_arbuffer[i]) < 
 			       sizeof(index_unit)){
-				if (replex_fill_buffers(rx, 0)< 0) {
+				if (replex_fill_buffers(rx, 0)< 0){
 					fprintf(stderr,
 						"error in fix audio\n");
 					exit(1);
 				}	
 			}
-			ring_peek(&rx->index_arbuffer[i], (uint8_t *)&aiu, size, 0);
+			ring_peek(&rx->index_arbuffer[i], (uint8_t *)&aiu, 
+				  size, 0);
 			if ( ptscmp(aiu.pts + rx->first_apts[i], rx->first_vpts) < 0){
 				ring_skip(&rx->index_arbuffer[i], size);
 				ring_skip(&rx->arbuffer[i], aiu.length);
 			} else break;
 
 		} while (1);
-		mx->ext[i].pts_off = aiu.pts;
+		mx->apts_off[i] = aiu.pts;
+		rx->apts_off[i] = aiu.pts;
+		mx->aframes[i] = aiu.framesize;
 		
 		fprintf(stderr,"Audio%d  offset: ",i);
-		printpts(mx->ext[i].pts_off);
-		printpts(rx->first_apts[i]+mx->ext[i].pts_off);
+		printpts(mx->apts_off[i]);
+		printpts(rx->first_apts[i]+mx->apts_off[i]);
 		fprintf(stderr,"\n");
 	}
 			  
@@ -1926,24 +2144,25 @@
 		do {
 			while (ring_avail(&rx->index_ac3rbuffer[i]) < 
 			       sizeof(index_unit)){
-				if (replex_fill_buffers(rx, 0)< 0) {
+				if (replex_fill_buffers(rx, 0)< 0){
 					fprintf(stderr,
 						"error in fix audio\n");
 					exit(1);
 				}	
 			}
-			ring_peek(&rx->index_ac3rbuffer[i], (uint8_t *)&aiu, 
+			ring_peek(&rx->index_ac3rbuffer[i],(uint8_t *) &aiu, 
 				  size, 0);
 			if ( ptscmp (aiu.pts+rx->first_ac3pts[i], rx->first_vpts) < 0){
 				ring_skip(&rx->index_ac3rbuffer[i], size);
 				ring_skip(&rx->ac3rbuffer[i], aiu.length);
 			} else break;
 		} while (1);
-		mx->ext[i].pts_off = aiu.pts;
+		mx->ac3pts_off[i] = aiu.pts;
+		rx->ac3pts_off[i] = aiu.pts;
 		
 		fprintf(stderr,"AC3%d  offset: ",i);
-		printpts(mx->ext[i].pts_off);
-		printpts(rx->first_ac3pts[i]+mx->ext[i].pts_off);
+		printpts(mx->ac3pts_off[i]);
+		printpts(rx->first_ac3pts[i]+mx->ac3pts_off[i]);
 		fprintf(stderr,"\n");
 
 	}
@@ -1973,7 +2192,7 @@
 
 static int get_next_ac3_unit(struct replex *rx, index_unit *aiu, int i)
 {
-	if (ring_avail(&rx->index_ac3rbuffer[i])) {
+	if (ring_avail(&rx->index_ac3rbuffer[i])){
 		ring_read(&rx->index_ac3rbuffer[i], (uint8_t *)aiu, 
 			  sizeof(index_unit));
 		
@@ -2005,7 +2224,7 @@
 	
 	
 	while(!rx->finish){
-		if (replex_fill_buffers(rx, 0)< 0) {
+		if (replex_fill_buffers(rx, 0)< 0){
 			fprintf(stderr,"error in get next video unit\n");
 			return;
 		}
@@ -2140,26 +2359,55 @@
 	index_unit dummy;
 	index_unit dummy2;
 	int i;
+	multiplex_t mx;
 	fprintf(stderr,"STARTING DEMUX\n");
+
+
+	while (!replex_all_set(rx)){
+		if (replex_fill_buffers(rx, 0)< 0){
+			fprintf(stderr,"error filling buffer\n");
+			exit(1);
+		}
+	}
+
+	fix_audio(rx, &mx);
 	
 	while(!rx->finish){
-		if (replex_fill_buffers(rx, 0)< 0) {
+		if (replex_fill_buffers(rx, 0)< 0){
 			fprintf(stderr,"error in get next video unit\n");
 			return;
 		}
 		for (i=0; i< rx->apidn; i++){
 			while(get_next_audio_unit(rx, &dummy2, i)){
-				ring_read_file(&rx->arbuffer[i], 
-					       rx->dmx_out[i+1], 
-					       dummy2.length);
+				switch(dummy2.err){
+				case JUMP_ERR:
+					ring_skip(&rx->arbuffer[i],dummy2.length);
+					break;
+				case DUMMY_ERR:
+					write(rx->dmx_out[i+1],dummy.fillframe,dummy2.length);
+					break; 
+				default:
+					ring_read_file(&rx->arbuffer[i], 
+						       rx->dmx_out[i+1], 
+						       dummy2.length);
+				}
 			}
 		}
 		
 		for (i=0; i< rx->ac3n; i++){
 			while(get_next_ac3_unit(rx, &dummy2, i)){
-				ring_read_file(&rx->ac3rbuffer[i], 
-					       rx->dmx_out[i+1+rx->apidn], 
-					       dummy2.length);
+				switch(dummy2.err){
+				case JUMP_ERR:
+					ring_skip(&rx->ac3rbuffer[i],dummy2.length);
+					break;
+				case DUMMY_ERR:
+					write(rx->dmx_out[i+1+rx->apidn],dummy.fillframe,dummy2.length);
+					break; 
+				default:
+					ring_read_file(&rx->ac3rbuffer[i], 
+						       rx->dmx_out[i+1+rx->apidn], 
+						       dummy2.length);
+				}
 			}
 		}
 		
@@ -2174,59 +2422,51 @@
 void do_replex(struct replex *rx)
 {
 	int video_ok = 0;
-	int ext_ok[N_AUDIO];
+	int audio_ok[N_AUDIO];
+	int ac3_ok[N_AC3];
 	int start=1;
 	multiplex_t mx;
+	int done = 0;
 
 
 	fprintf(stderr,"STARTING REPLEX\n");
 	memset(&mx, 0, sizeof(mx));
-	memset(ext_ok, 0, N_AUDIO*sizeof(int));
+	memset(audio_ok, 0, N_AUDIO*sizeof(int));
+	memset(ac3_ok, 0, N_AC3*sizeof(int));
 
 	while (!replex_all_set(rx)){
-		if (replex_fill_buffers(rx, 0)< 0) {
+		if (replex_fill_buffers(rx, 0)< 0){
 			fprintf(stderr,"error filling buffer\n");
 			exit(1);
 		}
 	}
 
- int i; 
-   for (i = 0; i < rx->apidn; i++){
-        rx->exttype[i] = 2;
-        rx->extframe[i] = rx->aframe[i];
-        rx->extrbuffer[i] = rx->arbuffer[i];
-        rx->index_extrbuffer[i] = rx->index_arbuffer[i];
-        rx->exttypcnt[i+1] = i;
-    }
-
-    int ac3Count = 1;
-    for (i = rx->apidn; i < rx->apidn + rx->ac3n; i++){
-        rx->exttype[i] = 1;
-        rx->extframe[i] = rx->ac3frame[i];
-        rx->extrbuffer[i] = rx->ac3rbuffer[i];
-        rx->index_extrbuffer[i] = rx->index_ac3rbuffer[i];
-        rx->exttypcnt[i] = ac3Count++;
-    }
-
-    mx.priv = (void *) rx;
+	mx.priv = (void *) rx;
 	rx->priv = (void *) &mx;
-    init_multiplex(&mx, &rx->seq_head, rx->extframe,
-                 rx->exttype, rx->exttypcnt, rx->video_delay, 
-                 rx->audio_delay, rx->fd_out, fill_buffers,
-                 &rx->vrbuffer, &rx->index_vrbuffer,  
-                 rx->extrbuffer, rx->index_extrbuffer,
-                 rx->otype);
+	init_multiplex(&mx, &rx->seq_head, rx->aframe, rx->ac3frame, 
+		       rx->apidn, rx->ac3n, rx->video_delay, 
+		       rx->audio_delay, rx->fd_out, fill_buffers,
+		       &rx->vrbuffer, &rx->index_vrbuffer,	
+		       rx->arbuffer, rx->index_arbuffer,
+		       rx->ac3rbuffer, rx->index_ac3rbuffer, rx->otype);
 
 	if (!rx->ignore_pts){ 
 		fix_audio(rx, &mx);
 	}
 	setup_multiplex(&mx);
 
-	while(1){
-		check_times( &mx, &video_ok, ext_ok, &start);
+	do {
+		check_times( &mx, &video_ok, audio_ok, ac3_ok, &start);
 
-		write_out_packs( &mx, video_ok, ext_ok);
-	}
+		write_out_packs( &mx, video_ok, audio_ok, ac3_ok);
+	
+		if (mx.max_reached) done = 1;
+		if (mx.zero_write_count >100){
+			fprintf(stderr,"Can`t continue, check input file\n");
+			done=1;
+		}
+	} while (!done);
+	
 }
 
 
@@ -2234,159 +2474,202 @@
 {
         printf ("usage: %s [options] <input files>\n\n",progname);
         printf ("options:\n");
-        printf ("  --help,             -h:  print help message\n");
-        printf ("  --type,             -t:  set output type (MPEG2, DVD, HDTV)\n");
-        printf ("  --of,               -o:  set output file\n");
-        printf ("  --input_stream,     -i:  set input stream type (TS(default), PS, AVI)\n");
-        printf ("  --audio_pid,        -a:  audio PID for TS stream (also used for PS id)\n");
-        printf ("  --ac3_id,           -c:  ID of AC3 audio for demux (also used for PS id)\n");
-        printf ("  --video_pid,        -v:  video PID for TS stream (also used for PS id)\n");
-        printf ("  --video_delay,      -d:  video delay in ms\n");
-        printf ("  --audio_delay,      -e:  audio delay in ms\n");
-        printf ("  --ignore_PTS,       -f:  ignore all PTS information of original\n");
-        printf ("  --keep_PTS,         -k:  keep and don't correct PTS information of original\n");
-        printf ("  --fix_sync,         -n:  try to fix audio sync while demuxing\n");
-        printf ("  --demux,            -z:  demux only (-o is basename)\n");
-        printf ("  --analyze,          -y:  analyze (0=video,1=audio, 2=both)\n");
-        printf ("  --scan,             -s:  scan for streams\n");
-        printf ("  --vdr,              -x:  handle AC3 for vdr input file\n");
+        printf ("  --help,             -h            :  print help message\n");
+        printf ("\n");
+        printf ("  --audio_pid,        -a <integer>  :  audio PID for TS stream (also used for PS id, default 0xc0)\n");
+        printf ("  --ac3_id,           -c <integer>  :  ID of AC3 audio for demux (also used for PS id, i.e. 0x80)\n");
+        printf ("  --video_delay,      -d <integer>  :  video delay in ms\n");
+        printf ("  --audio_delay,      -e <integer>  :  audio delay in ms\n");
+        printf ("  --ignore_PTS,       -f            :  ignore all PTS information of original\n");
+	printf ("  --larger_buffer     -g <integer>  :  video buffer in MB\n"); 
+        printf ("  --input_stream,     -i <string>   :  set input stream type (string = TS(default), PS, AVI)\n");
+        printf ("  --allow_jump,       -j            :  allow jump in the PTS and try repair\n");
+        printf ("  --keep_PTS,         -k            :  keep and don't correct PTS information of original\n");
+	printf ("  --min_jump,         -l <integer>  :  don't try to fix jumps in PTS larger than <int> but treat them as a cut (default 100ms)\n");
+        printf ("  --of,               -o <filename> :  set output file\n");
+	printf ("  --fillzero          -p            :  fill audio frames with zeros (only MPEG AUDIO)\n");
+	printf ("  --max_overflow      -q <integer>  :  max_number of overflows allowed (default: 100, 0=no restriction)\n");
+        printf ("  --scan,             -s            :  scan for streams\n");
+        printf ("  --type,             -t <string>   :  set output type (string = MPEG2, DVD, HDTV)\n");
+        printf ("  --video_pid,        -v <integer>  :  video PID for TS stream (also used for PS id, default 0xe0)\n");
+        printf ("  --vdr,              -x            :  handle AC3 for vdr input file\n");
+        printf ("  --analyze,          -y <integer>  :  analyze (0=video,1=audio, 2=both)\n");
+        printf ("  --demux,            -z            :  demux only (-o is basename)\n");
         exit(1);
 }
 
 int main(int argc, char **argv)
 {
-	int c;
+        int c;
 	int analyze=0;
 	int scan =0;
-	char *filename = NULL;
-	char *type = "SVCD";
-	char *inpt = "TS";
+        char *filename = NULL;
+        char *type = "SVCD";
+        char *inpt = "TS";
+	int bufsize = 6*1024*1024;
+	uint64_t min_jump=0;
+	int fillzero = 0;
 
 	struct replex rx;
 
+	fprintf(stderr,"replex version Myth-Internal");
+
 	memset(&rx, 0, sizeof(struct replex));
+	rx.max_overflows = 100;
 
-	while (1) {
-		int option_index = 0;
-		static struct option long_options[] = {
-			{"type", required_argument, NULL, 't'},
-			{"input_stream", required_argument, NULL, 'i'},
-			{"video_pid", required_argument, NULL, 'v'},
+        while (1){
+                int option_index = 0;
+                static struct option long_options[] = {
 			{"audio_pid", required_argument, NULL, 'a'},
+			{"ac3_id", required_argument, NULL, 'c'},
+			{"video_delay", required_argument, NULL, 'd'},
 			{"audio_delay", required_argument, NULL, 'e'},
-			{"video_delay", required_argument, NULL, 'd'},
-			{"ac3_id", required_argument, NULL, 'c'},
-			{"of",required_argument, NULL, 'o'},
 			{"ignore_PTS",required_argument, NULL, 'f'},
+			{"larger_buffer",required_argument, NULL, 'g'},
+			{"help", no_argument , NULL, 'h'},
+			{"input_stream", required_argument, NULL, 'i'},
+			{"allow_jump",required_argument, NULL, 'j'},
 			{"keep_PTS",required_argument, NULL, 'k'},
-			{"fix_sync",no_argument, NULL, 'n'},
-			{"demux",no_argument, NULL, 'z'},
-			{"analyze",required_argument, NULL, 'y'},
+			{"min_jump",required_argument, NULL, 'l'},
+			{"of",required_argument, NULL, 'o'},
+			{"fillzero",required_argument, NULL, 'p'},
+			{"max_overflow",required_argument, NULL, 'q'},
 			{"scan",required_argument, NULL, 's'},
+			{"type", required_argument, NULL, 't'},
+			{"video_pid", required_argument, NULL, 'v'},
 			{"vdr",required_argument, NULL, 'x'},
-			{"help", no_argument , NULL, 'h'},
+			{"analyze",required_argument, NULL, 'y'},
+			{"demux",no_argument, NULL, 'z'},
 			{0, 0, 0, 0}
 		};
-		c = getopt_long (argc, argv, 
-					"t:o:a:v:i:hp:q:d:c:n:fkd:e:zy:sx",
+                c = getopt_long (argc, argv, 
+				 "a:c:d:e:fg:hi:jkl:o:pq:st:v:xy:z",
                                  long_options, &option_index);
-		if (c == -1)
-    		break;
+                if (c == -1)
+                        break;
 
-		switch (c) {
-		case 't':
-			type = optarg;
-			break;
-		case 'i':
-			inpt = optarg;
-			break;
-		case 'd':
-			rx.video_delay = strtol(optarg,(char **)NULL, 0) 
-				*CLOCK_MS;
-			break;
-		case 'e':
-			rx.audio_delay = strtol(optarg,(char **)NULL, 0) 
-				*CLOCK_MS;
-			break;
-		case 'a':
+                switch (c){
+                case 'a':
 			if (rx.apidn==N_AUDIO){
 				fprintf(stderr,"Too many audio PIDs\n");
 				exit(1);
 			}
                         rx.apid[rx.apidn] = strtol(optarg,(char **)NULL, 0);
 			rx.apidn++;
-			break;
-		case 'v':
-			rx.vpid = strtol(optarg,(char **)NULL, 0);
-			break;
-		case 'c':
+                        break;
+                case 'c':
 			if (rx.ac3n==N_AC3){
 				fprintf(stderr,"Too many audio PIDs\n");
 				exit(1);
 			}
-			rx.ac3_id[rx.ac3n] = strtol(optarg,(char **)NULL, 0);
+                        rx.ac3_id[rx.ac3n] = strtol(optarg,(char **)NULL, 0);
 			rx.ac3n++;
+                        break;
+		case 'd':
+			rx.video_delay = strtol(optarg,(char **)NULL, 0) 
+				*CLOCK_MS;
 			break;
-		case 'o':
-			filename = optarg;
+		case 'e':
+			rx.audio_delay = strtol(optarg,(char **)NULL, 0) 
+				*CLOCK_MS;
 			break;
 		case 'f':
 			rx.ignore_pts =1;
 			break;
+		case 'g':
+			bufsize = strtol(optarg,(char **)NULL, 0) *1024*1024; 
+			break;
+                case 'i':
+                        inpt = optarg;
+                        break;
+                case 'j':
+                        rx.allow_jump = MIN_JUMP;
+                        break;
 		case 'k':
 			rx.keep_pts =1;
 			break;
-		case 'z':
-			rx.demux =1;
+		case 'l':
+			min_jump = strtol(optarg,(char **)NULL, 0) *CLOCK_MS; 
 			break;
-		case 'n':
-			rx.fix_sync =1;
+                case 'o':
+                        filename = optarg;
+                        break;
+		case 'p':
+			fillzero = 1;
 			break;
-		case 'y':
-			analyze = strtol(optarg,(char **)NULL, 0);
-			if (analyze>2) usage(argv[0]);
-			analyze++;
+		case 'q':
+			rx.max_overflows = strtol(optarg,(char **)NULL, 0); 
 			break;
 		case 's':
 			scan = 1;
 			break;
+                case 't':
+                        type = optarg;
+                        break;
+                case 'v':
+                        rx.vpid = strtol(optarg,(char **)NULL, 0);
+                        break;
 		case 'x':
 			rx.vdr=1;
 			break;
-		case 'h':
-		case '?':
-		default:
-			usage(argv[0]);
+		case 'y':
+			analyze = strtol(optarg,(char **)NULL, 0);
+			if (analyze>2) usage(argv[0]);
+			analyze++;
+			break;
+		case 'z':
+			rx.demux = 1;
+			break;
+                case 'h':
+                case '?':
+                default:
+                        usage(argv[0]);
+                }
+        }
+
+	if (rx.allow_jump && min_jump) rx.allow_jump = min_jump;
+
+	if (fillzero) rx.fillzero = 1;
+	rx.inputFiles = NULL;
+        if (optind < argc){
+		int i = 0;
+		rx.inputFiles = calloc( sizeof(char * ), argc - optind + 1);
+		while (optind < argc) {
+			if ((rx.fd_in = open(argv[optind] ,O_RDONLY| O_LARGEFILE)) < 0){
+				fprintf(stderr,"Error opening input file %s",argv[optind] );
+				exit(1);
+			}
+			close(rx.fd_in);
+			rx.inputFiles[i] = argv[optind];
+			i++;
+			optind++;
 		}
-	}
-
-	if (rx.fix_sync)
-		av_register_all();
-	
-	if (optind == argc-1) {
-		if ((rx.fd_in = open(argv[optind] ,O_RDONLY| O_LARGEFILE)) < 0) {
-			perror("Error opening input file ");
+		rx.inputFiles[i] = NULL;
+		rx.inputIdx = 0;
+		if ((rx.fd_in = open(rx.inputFiles[0] ,O_RDONLY| O_LARGEFILE)) < 0) {
+			fprintf(stderr,"Error opening input file %s",argv[optind] );
 			exit(1);
 		}
-		fprintf(stderr,"Reading from %s\n", argv[optind]);
+
+                fprintf(stderr,"Reading from %s\n", argv[optind]);
 		rx.inflength = lseek(rx.fd_in, 0, SEEK_END);
 		fprintf(stderr,"Input file length: %.2f MB\n",rx.inflength/1024./1024.);
 		lseek(rx.fd_in,0,SEEK_SET);
 		rx.lastper = 0;
 		rx.finread = 0;
-	} else {
+        } else {
 		fprintf(stderr,"using stdin as input\n");
 		rx.fd_in = STDIN_FILENO;
 		rx.inflength = 0;
-	}
+        }
 
 	if (!rx.demux){
 		if (filename){
 			if ((rx.fd_out = open(filename,O_WRONLY|O_CREAT
-					|O_TRUNC|O_LARGEFILE,
-					S_IRUSR|S_IWUSR|S_IRGRP|
-					S_IWGRP|
-					S_IROTH|S_IWOTH)) < 0){
+					      |O_TRUNC|O_LARGEFILE,
+					      S_IRUSR|S_IWUSR|S_IRGRP|
+					      S_IWGRP|
+					      S_IROTH|S_IWOTH)) < 0){
 				perror("Error opening output file");
 				exit(1);
 			}
@@ -2406,16 +2689,16 @@
 		exit(0);
 	}
 
-	if (!strncmp(type,"MPEG2",6))
+        if (!strncmp(type,"MPEG2",6))
 		rx.otype=REPLEX_MPEG2;
 	else if (!strncmp(type,"DVD",4))
 		rx.otype=REPLEX_DVD;
 	else if (!strncmp(type,"HDTV",4))
 		rx.otype=REPLEX_HDTV;
-	else if (!rx.demux)
-		usage(argv[0]);
+        else if (!rx.demux && !analyze)
+                usage(argv[0]);
 	
-	if (!strncmp(inpt,"TS",3)){
+        if (!strncmp(inpt,"TS",3)){
 		rx.itype=REPLEX_TS;
 	} else if (!strncmp(inpt,"PS",3)){
 		rx.itype=REPLEX_PS;
@@ -2431,13 +2714,13 @@
 		rx.apid[0] = 0xC0;
 		rx.ignore_pts =1;
 	} else {
-		usage(argv[0]);
+                usage(argv[0]);
 	}
 
-	init_replex(&rx);
+	init_replex(&rx, bufsize);
 	rx.analyze= analyze;
 
-	if (rx.demux) {
+	if (rx.demux){
 		int i;
 		char fname[256];
 		if (!filename){
@@ -2504,6 +2787,6 @@
 	} else {
 		do_replex(&rx);
 	}
-
+	
 	return 0;
 }
Index: replex/mpg_common.h
===================================================================
--- replex/mpg_common.h	(revision 18755)
+++ replex/mpg_common.h	(working copy)
@@ -2,8 +2,10 @@
  * mpg_common.h
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
+ *           (C) 2006 Reel Multimedia
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -47,31 +49,22 @@
 	uint8_t  frame_off;
 	uint8_t  frame_start;
 	uint8_t  err;
-	uint32_t framesize;
-	uint64_t ptsrate;
+	int      framesize;
+	uint8_t  *fillframe;
 } index_unit;
 
-typedef struct extdata_s{
-	index_unit iu;
-	uint64_t pts;
-	uint64_t pts_off;
-        int type;
-        int strmnum;
-	int frmperpkt;
-	char language[4];
-	dummy_buffer dbuf;
-} extdata_t;
-
-
 #define NO_ERR    0
 #define FRAME_ERR 1
+#define PTS_ERR 2
+#define JUMP_ERR 3
+#define DUMMY_ERR 4
+#define DROP_ERR 5
 
-
 void show_buf(uint8_t *buf, int length);
 int find_mpg_header(uint8_t head, uint8_t *buf, int length);
 int find_any_header(uint8_t *head, uint8_t *buf, int length);
 uint64_t trans_pts_dts(uint8_t *pts);
-int mring_peek( ringbuffer *rbuf, uint8_t *buf, unsigned int l, uint32_t off);
+int mring_peek( ringbuffer *rbuf, uint8_t *buf, int l, long off);
 int ring_find_mpg_header(ringbuffer *rbuf, uint8_t head, int off, int le);
 int ring_find_any_header(ringbuffer *rbuf, uint8_t *head, int off, int le);
 
Index: replex/replex.h
===================================================================
--- replex/replex.h	(revision 18755)
+++ replex/replex.h	(working copy)
@@ -2,8 +2,10 @@
  * replex.h
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
+ *           (C) 2006 Reel Multimedia
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -36,6 +38,8 @@
 #include "multiplex.h"
 
 enum { S_SEARCH, S_FOUND, S_ERROR };
+#define MIN_JUMP 100*CLOCK_MS;
+#define MAXFRAME 2000
 
 struct replex {
 #define REPLEX_TS  0
@@ -45,7 +49,7 @@
 	int otype;
 	int ignore_pts; 
 	int keep_pts;
-	int fix_sync;
+	uint64_t allow_jump;
 	uint64_t inflength;
 	uint64_t finread;
 	int lastper;
@@ -59,25 +63,19 @@
 	int analyze;
 	avi_context ac;
 	int vdr;
+	int fillzero;
+	int overflows;
+	int max_overflows;
 
 	uint64_t video_delay;
 	uint64_t audio_delay;
 
-#define VIDEO_BUF (6*1024*1024)
-#define AUDIO_BUF (VIDEO_BUF/10)
-#define AC3_BUF   (VIDEO_BUF/10)
 #define INDEX_BUF (32000*32)
+
 	int audiobuf;
 	int ac3buf;
 	int videobuf;
 
-    int ext_count;
-    int exttype[N_AUDIO];
-    int exttypcnt[N_AUDIO];
-    audio_frame_t extframe[N_AUDIO];
-    ringbuffer extrbuffer[N_AUDIO];
-    ringbuffer index_extrbuffer[N_AUDIO];
-
   //ac3 
 	int ac3n;
 	uint16_t ac3_id[N_AC3];
@@ -91,7 +89,12 @@
 	uint64_t first_ac3pts[N_AC3];
 	int ac3_state[N_AUDIO];
 	uint64_t last_ac3pts[N_AC3];
+	uint64_t ac3_jump[N_AUDIO];
+	uint64_t ac3pts_off[N_AC3];
+	uint8_t  ac3fillframe[N_AC3][MAXFRAME];
+	int  ac3filled[N_AC3];
 
+
 // mpeg audio
 	int apidn;
 	uint16_t apid[N_AUDIO];
@@ -105,6 +108,10 @@
 	uint64_t first_apts[N_AUDIO];
 	int audio_state[N_AUDIO];
 	uint64_t last_apts[N_AUDIO];
+	uint64_t audio_jump[N_AUDIO];
+	uint64_t apts_off[N_AUDIO];
+	uint8_t  afillframe[N_AC3][MAXFRAME];
+	int  afilled[N_AC3];
 
 //mpeg video
         uint16_t vpid;
@@ -120,9 +127,13 @@
 	uint64_t first_vpts;
 	int video_state;
 	uint64_t last_vpts;
+	uint64_t video_jump;
+	uint64_t vjump_pts;
 
 	void *priv;
 	int scan_found;
+        char **inputFiles;
+        int inputIdx;
 };
 
 void init_index(index_unit *iu);
Index: replex/README
===================================================================
--- replex/README	(revision 18755)
+++ replex/README	(working copy)
@@ -6,29 +6,36 @@
 usage: ./replex [options] <input files>
  
 options:
-  --help,             -h:  print help message
-  --type,             -t:  set output type (MPEG2, DVD, HDTV)
-  --of,               -o:  set output file
-  --input_stream,     -i:  set input stream type (TS(default), PS, AVI)
-  --audio_pid,        -a:  audio PID for TS stream (also used for PS id)
-  --ac3_id,           -c:  ID of AC3 audio for demux (also used for PS id)
-  --video_pid,        -v:  video PID for TS stream (also used for PS id)
-  --video_delay,      -d:  video delay in ms
-  --audio_delay,      -e:  audio delay in ms
-  --ignore_PTS,       -f:  ignore all PTS information of original
-  --keep_PTS,         -k:  keep and don't correct PTS information of original
-  --demux,            -z:  demux only (-o is basename)
-  --analyze,          -y:  analyze (0=video,1=audio, 2=both)
-  --scan,             -s:  scan for streams  
-  --vdr,              -x:  handle AC3 for vdr input file
+  --help,             -h            :  print help message
 
+  --audio_pid,        -a <integer>  :  audio PID for TS stream (also used for PS id, default 0xc0)
+  --ac3_id,           -c <integer>  :  ID of AC3 audio for demux (also used for PS id, i.e. 0x80)
+  --video_delay,      -d <integer>  :  video delay in ms
+  --audio_delay,      -e <integer>  :  audio delay in ms
+  --ignore_PTS,       -f            :  ignore all PTS information of original
+  --larger_buffer     -g <integer>  :  video buffer in MB
+  --input_stream,     -i <string>   :  set input stream type (string = TS(default), PS, AVI)
+  --allow_jump,       -j            :  allow jump in the PTS and try repair
+  --keep_PTS,         -k            :  keep and don't correct PTS information of original
+  --min_jump,         -l <integer>  :  don't try to fix jumps in PTS larger than <int> but treat them as a cut (default 100ms)
+  --of,               -o <filename> :  set output file
+  --fillzero          -p            :  fill audio frames with zeros (only MPEG AUDIO)
+  --max_overflow      -q <integer>  :  max_number of overflows allowed (default: 100, 0=no restriction)
+  --scan,             -s            :  scan for streams
+  --type,             -t <string>   :  set output type (string = MPEG2, DVD, HDTV)
+  --video_pid,        -v <integer>  :  video PID for TS stream (also used for PS id, default 0xe0)
+  --vdr,              -x            :  handle AC3 for vdr input file
+  --analyze,          -y <integer>  :  analyze (0=video,1=audio, 2=both)
+  --demux,            -z            :  demux only (-o is basename)
+
 A typical call would be
 replex -t DVD -o mynewps.mpg myoldts.ts
 
 Replex can guess the PIDs of your audio and video streams, but
 especially if you have more than one audio stream you should use the
 -v and -a or -c options. The -a and -c options can be used more than
-once to create multiple audio tracks.
+once to create multiple audio tracks. Use the -s option to find out 
+about the PIDs in your file
 
 The -k option means that replex tries to keep the original PTS spacing,
 which can be helpful in case of corrupt streams. Replex will ignore
@@ -39,4 +46,16 @@
 from t]he original and creates the PTS according to the frames that are
 found.
 
+The -j option lets replex jump over PTS discontiniuties like the ones
+you get from cutting an MPEG file. With -l you can set the minimum time 
+a jump has to have to get treated as cut. The default for that is 100ms.
+If you have video jumps without any audio jumps and they are larger than 
+100ms (usually > 2 frames) you can try increasing the min_jump setting.
+If you set it too high and you have real jumps, e.g. audio and video 
+jumps from a cut, they may not get fixed correctly.
+
+
+The -g option can be helpful if you get ringbuffer overflows, it increases
+the video buffer size. Default is 6MB.
+
 For questions and/or suggestions contact me at mocm@metzlerbros.de. 
Index: replex/avi.c
===================================================================
--- replex/avi.c	(revision 18755)
+++ replex/avi.c	(working copy)
@@ -2,7 +2,8 @@
  * avi.c: AVI container functions for replex
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
  *
  * This program is free software; you can redistribute it and/or
